; This program demonstrates using the keyboard and controller ports directly
;  to place a letter into the keyboard buffer, which will be printed to the
;  screen when the program terminates, or (if code altered as stated below)
;  move the byte into a register where you can deal with it. 

; no stack or data segment needed

code segment            'code'
assume cs:code

start:


; Place code for "shift" into buffer
mov al, 0d3h    ; Write output buffer and set AUXB in status register 
out 64h,al

testit:
in al, 64h      ; Check status register 
test al, 02h    ; If bit 1 is set, then port must first be read before it 
                ;  can be witten
jnz testit      ; Try again
mov al,42d      ; Scan code for "shift-pressed"
out 60h, al     ; Load the port
int 09h         ; Sends the byte to the keyboard buffer, which will print
                ;  it to the screen when the program exits, and dumps the
                ;  buffer.

;Place code for "c" into buffer
mov al, 0d3h   ; Write output buffer and set AUXB in status register   
out 64h,al

testit2:
in al, 64h      ; Check status register 
test al, 02h    ; If bit 1 is set, then port must first be read before it 
                ;  can be witten
jnz testit2     ; Try again
mov al,46d      ; Scan code for letter "c"
out 60h, al     ; Load the port
int 09h         ; Sends the byte to the keyboard buffer, which will print
                ;  it to the screen when the program exits, and dumps the
                ;  buffer.

; Reset "shift" state (capitals) to "no-shift"
mov al, 0d3h    ; Write output buffer and set AUXB in status register 
out 64h,al

testit3:
in al, 64h      ; Check status register 
test al, 02h    ; If bit 1 is set, then port must first be read before it 
                ;  can be witten
jnz testit3     ; Try again
mov al, 170     ; Scan code for "shift release"
out 60h, al     ; Load the port
int 09h         ; Sends the byte to the keyboard buffer, which will print
                ;  it to the screen when the program exits, and dumps the
                ;  buffer.

; if the  int/function below is used, then the buffer will be read and the 
;  scan  code  will  be sent to ax. If not then key will be printed to the 
;  screen when the program terminates, and the buffer is flushed.
;mov ah,00
;int 16h

mov ah,04ch
int 21h

code ends
end start
end
